#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <celltrie>

#include <CSWeaponsUtil>

#define PLUGIN "CS Weapons Util"
#define VERSION "1.0"
#define AUTHOR "R3X"

enum CSWeaponCmd{
	BuyName[32],
	WeaponId
};

new Trie:gWeaponsIds;

new gWeaponCommands[][CSWeaponCmd] = {
	{ "p228", 		CSW_P228 	}, 	{ "228compact", 	CSW_P228 	},
	{ "shield", 		_CSW_SHIELD 	 },
	{ "scout",  		CSW_SCOUT 	},
	{ "hegren",  		CSW_HEGRENADE 	},
	{ "xm1014",  		CSW_XM1014	},	{ "autoshotgun",  	CSW_XM1014	},
	{ "mac10",  		CSW_MAC10	},
	{ "aug",  		CSW_AUG		},	{ "bullpup",  		CSW_AUG		},
	{ "sgren",  		CSW_SMOKEGRENADE},
	{ "elites",  		CSW_ELITE 	},
	{ "fn57",  		CSW_FIVESEVEN 	},	{ "fiveseven",  		CSW_FIVESEVEN 	},
	{ "ump45",  		CSW_UMP45	},
	{ "sg550",  		CSW_SG550	},	{ "krieg550",  		CSW_SG550	},
	{ "galil",  		CSW_GALIL	},	{ "defender",  		CSW_GALIL	},
	{ "famas",  		CSW_FAMAS	},	{ "clarion",  		CSW_FAMAS	},
	{ "usp",  		CSW_USP		},	{ "km45",  		CSW_USP		},
	{ "glock",  		CSW_GLOCK18	},	{ "9x19mm",  		CSW_GLOCK18	},
	{ "awp",  		CSW_AWP		},	{ "magnum",  		CSW_AWP		},
	{ "mp5",  		CSW_MP5NAVY	},	{ "smg",  		CSW_MP5NAVY	},
	{ "m249",  		CSW_M249	},
	{ "m3",  		CSW_M3		},	{ "12gauge",  		CSW_M3		},
	{ "m4a1",  		CSW_M4A1	},
	{ "tmp",  		CSW_TMP		},	{ "mp",  		CSW_TMP		},
	{ "g3sg1",  		CSW_G3SG1	},	{ "d3au1",  		CSW_G3SG1	},
	{ "flash",  		CSW_FLASHBANG	},	
	{ "deagle",  		CSW_DEAGLE	},	{ "nighthawk",  		CSW_DEAGLE	},
	{ "sg552",  		CSW_SG552	},	{ "krieg552",  		CSW_SG552	},
	{ "ak47",  		CSW_AK47	},	{ "cv47",  		CSW_AK47	},
	{ "p90",  		CSW_P90		},	{ "c90",  		CSW_P90		},
	{ "primammo",  		_CSW_PRIMAMMO},
	{ "secammo",  		_CSW_SECAMMO},
	{ "buyammo1",  		_CSW_BUYAMMO1},
	{ "buyammo2",  		_CSW_BUYAMMO2},
	{ "nvgs",  		_CSW_NVGS},
	{ "defuser",  		_CSW_DEFUSER},
	{ "vest",  		_CSW_VEST},
	{ "vesthelm",  		_CSW_VESTHELM}
};

new gfwOnBuyItem;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	gWeaponsIds = TrieCreate();
	
	//VGUI and commands
	for(new i=0; i< sizeof(gWeaponCommands); i++)
	{
		register_clcmd( gWeaponCommands[i][BuyName] , "cmdBuyWeapon");
		
		TrieSetCell(gWeaponsIds, gWeaponCommands[i][BuyName], gWeaponCommands[i][WeaponId]);
	}
	
	//Old Style menu
	register_menucmd(register_menuid("#Buy"), 		0xFFFFFFFF, "MenuBuyPressed");
	register_menucmd(register_menuid("BuyPistol"), 		0xFFFFFFFF, "MenuBuyPistolPressed");
	register_menucmd(register_menuid("BuyShotgun"), 	0xFFFFFFFF, "MenuBuyShotgunPressed");
	register_menucmd(register_menuid("BuySubMachineGun"), 	0xFFFFFFFF, "MenuBuySMGPressed");
	register_menucmd(register_menuid("BuyRifle"), 		0xFFFFFFFF, "MenuBuyRiflePressed");
	register_menucmd(register_menuid("BuyMachineGun"), 	0xFFFFFFFF, "MenuBuyMGPressed");

	register_menucmd(register_menuid("BuyItem"), 		0xFFFFFFFF, "MenuBuyItemPressed");
	
	gfwOnBuyItem = CreateMultiForward("CS_OnBuyItem", ET_STOP, FP_CELL, FP_CELL);
}

public MenuBuyPressed(id, key)
{
	switch(key)
	{
		case 5:	return onWeaponBuy(id, _CSW_PRIMAMMO);
		case 6:	return onWeaponBuy(id, _CSW_SECAMMO);
	}
	return PLUGIN_CONTINUE;
}
/**
 * Pistols
 */
public MenuBuyPistolPressed(id, key)
{
	switch(cs_get_user_team(id))
	{
		case CS_TEAM_CT: 	return MenuCTBuyPistolPressed(id, key);
		case CS_TEAM_T: 	return MenuTBuyPistolPressed(id, key);
	}
	return PLUGIN_CONTINUE;
}

public MenuCTBuyPistolPressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_GLOCK18);
		case 1: return onWeaponBuy(id, CSW_USP);
		case 2: return onWeaponBuy(id, CSW_P228);
		case 3: return onWeaponBuy(id, CSW_DEAGLE);
		case 4: return onWeaponBuy(id, CSW_FIVESEVEN);
			
	}
	return PLUGIN_CONTINUE;
}

public MenuTBuyPistolPressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_GLOCK18);
		case 1: return onWeaponBuy(id, CSW_USP);
		case 2: return onWeaponBuy(id, CSW_P228);
		case 3: return onWeaponBuy(id, CSW_DEAGLE);
		case 4: return onWeaponBuy(id, CSW_ELITE);
			
	}
	return PLUGIN_CONTINUE;
}

/**
 * Shotguns
 */
public MenuBuyShotgunPressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_M3);
		case 1: return onWeaponBuy(id, CSW_XM1014);		
	}
	return PLUGIN_CONTINUE;
}

/**
 * SMG
 */
public MenuBuySMGPressed(id, key)
{
	switch(cs_get_user_team(id))
	{
		case CS_TEAM_CT: 	return MenuCTBuySMGPressed(id, key);
		case CS_TEAM_T: 	return MenuTBuySMGPressed(id, key);
	}
	return PLUGIN_CONTINUE;
}

public MenuCTBuySMGPressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_TMP);
		case 1: return onWeaponBuy(id, CSW_MP5NAVY);		
		case 2: return onWeaponBuy(id, CSW_UMP45);		
		case 3: return onWeaponBuy(id, CSW_P90);		
	}
	return PLUGIN_CONTINUE;
}

public MenuTBuySMGPressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_MAC10);
		case 1: return onWeaponBuy(id, CSW_MP5NAVY);		
		case 2: return onWeaponBuy(id, CSW_UMP45);		
		case 3: return onWeaponBuy(id, CSW_P90);			
	}
	return PLUGIN_CONTINUE;
}

/**
 * RIFLES
 */
public MenuBuyRiflePressed(id, key)
{
	switch(cs_get_user_team(id))
	{
		case CS_TEAM_CT: 	return MenuCTBuyRiflePressed(id, key);
		case CS_TEAM_T: 	return MenuTBuyRiflePressed(id, key);
	}
	return PLUGIN_CONTINUE;
}
public MenuCTBuyRiflePressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_FAMAS);
		case 1: return onWeaponBuy(id, CSW_SCOUT);
		case 2: return onWeaponBuy(id, CSW_M4A1);		
		case 3: return onWeaponBuy(id, CSW_AUG);			
		case 4: return onWeaponBuy(id, CSW_SG550);			
		case 5: return onWeaponBuy(id, CSW_AWP);		
	}
	return PLUGIN_CONTINUE;
}

public MenuTBuyRiflePressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_GALIL);
		case 1: return onWeaponBuy(id, CSW_AK47);		
		case 2: return onWeaponBuy(id, CSW_SCOUT);		
		case 3: return onWeaponBuy(id, CSW_SG552);			
		case 4: return onWeaponBuy(id, CSW_AWP);			
		case 5: return onWeaponBuy(id, CSW_G3SG1);			
	}
	return PLUGIN_CONTINUE;
}

/**
 * MG
 */
public MenuBuyMGPressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, CSW_M249);			
	}
	return PLUGIN_CONTINUE;
}


/**
 * Equipment
 */
public MenuBuyItemPressed(id, key)
{
	switch(key)
	{
		case 0: return onWeaponBuy(id, _CSW_VEST);			
		case 1: return onWeaponBuy(id, _CSW_VESTHELM);			
		case 2: return onWeaponBuy(id, CSW_FLASHBANG);			
		case 3: return onWeaponBuy(id, CSW_HEGRENADE);			
		case 4: return onWeaponBuy(id, CSW_SMOKEGRENADE);			
		case 5: return onWeaponBuy(id, _CSW_NVGS);			
		case 6: return onWeaponBuy(id, _CSW_DEFUSER);			
		case 7: return onWeaponBuy(id, _CSW_SHIELD);			
	}
	return PLUGIN_CONTINUE;
}

/**
 * Autobuy, rebuy
 */
public CS_InternalCommand( id , const szCmd[])
{
	new wid;
	if(TrieGetCell(gWeaponsIds, szCmd, wid))
	{
		return onWeaponBuy(id, wid);
	}
	return PLUGIN_CONTINUE;
}

public cmdBuyWeapon(id)
{
	new szCmd[32];
	read_argv(0, szCmd, 31);
	
	new wid;
	if(TrieGetCell(gWeaponsIds, szCmd, wid))
	{
		return onWeaponBuy(id, wid);
	}
	return PLUGIN_CONTINUE;
}

onWeaponBuy(id, weaponid)
{
	new iRet;
	ExecuteForward(gfwOnBuyItem, iRet, id, weaponid);
	return iRet;
}